package ru.amse.pomelov.starbugs.client.gui;


import java.util.List;

import javax.swing.JComponent;

import ru.amse.pomelov.starbugs.client.ClientDispatcher;
import ru.amse.pomelov.starbugs.server.GameField;
import ru.amse.pomelov.starbugs.units.AbstractUnit;
import ru.amse.pomelov.starbugs.util.FieldPosition;

public abstract class GameFieldView extends JComponent {
	
	public GameFieldView(ClientDispatcher clientDispatcher) {
		myClientDispatcher = clientDispatcher;
		myGameField = myClientDispatcher.getGameField();
		fieldWidth = myGameField.getWidth();
		fieldHeight = myGameField.getHeight();
	}
	
	protected int fieldWidth;

	protected int fieldHeight;

	protected GameField myGameField;

	protected final ClientDispatcher myClientDispatcher;

	public void putUnits(List<AbstractUnit> unitList) {
		for (AbstractUnit unit : unitList) {
			myGameField.putUnit(unit);
		}
	}
	
	public void removeUnit(FieldPosition coords) {
		myGameField.removeUnit(coords);
	}
}
