package ru.amse.pomelov.starbugs.client.gui;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.Scanner;

import javax.swing.ImageIcon;

import ru.amse.pomelov.starbugs.units.AbstractUnit;
import ru.amse.pomelov.starbugs.units.Building;
import ru.amse.pomelov.starbugs.units.Buildings;
import ru.amse.pomelov.starbugs.units.Unit;
import ru.amse.pomelov.starbugs.units.Units;

public class IconFactory {
	
	public static final String DEFAULT_ICON_SCHEMA = "Demian";
	
	private static String iconSchema = DEFAULT_ICON_SCHEMA;
	private static File allIcons;
	private static File unitIcons;
	private static File buttonUnitIcons;
	private static File buttonBuildingIcons;
	private static boolean isInit = false;
	

	private static void init() {
		if (isInit) {
			return;
		}
		
		File i = new File("Icons");
		if (i.exists()) {
			Scanner s;
			try {
				s = new Scanner(new File("Icons/schema"));
				iconSchema = s.nextLine();
			} catch (FileNotFoundException e) {	
			} finally {
				allIcons = new File("Icons/" + iconSchema);
				unitIcons = new File(allIcons, "Units");
				buttonUnitIcons = new File(allIcons, "Buttons/Units");
				buttonBuildingIcons = new File(allIcons, "Buttons/Buildings");				
			}
		}
		isInit = true;		
	}
	
	
	public static ImageIcon createIcon(Unit b) {
		init();
		return new ImageIcon(unitIcons.getAbsolutePath() + "/"
				+ b.getUnitType().getName() + ".png");
	}
	
	public static ImageIcon createIcon(Building b) {
		init();
		return new ImageIcon(allIcons.getAbsolutePath() + "/abstractBuilding.png");
	}
	
	public static ImageIcon createIcon(AbstractUnit u) {
		init();
		return new ImageIcon(allIcons.getAbsolutePath() + "/unknown.png");
	}
	
	
	
	public static ImageIcon createUnitButtonIcon(Units unitType) {
		init();
		return new ImageIcon(buttonUnitIcons.getAbsolutePath() + "/"
				+ unitType.getName() + "/simple.png");
	}
	
	public static ImageIcon createUnitPressedButtonIcon(Units unitType) {
		init();
		return new ImageIcon(buttonUnitIcons.getAbsolutePath() + "/"
				+ unitType.getName() + "/pressed.png");
	}
	
	public static ImageIcon createUnitDisableButtonIcon(Units unitType) {
		init();
		return new ImageIcon(buttonUnitIcons.getAbsolutePath() + "/"
				+ unitType.getName() + "/disable.png");
	}
	
	
	
	public static ImageIcon createBuildingButtonIcon(Buildings buildingType) {
		init();
		return new ImageIcon(buttonBuildingIcons.getAbsolutePath() + "/"
				+ buildingType.getName() + "/simple.png");
	}
	
	public static ImageIcon createBuildingPressedButtonIcon(Buildings buildingType) {
		init();
		return new ImageIcon(buttonBuildingIcons.getAbsolutePath() + "/"
				+ buildingType.getName() + "/pressed.png");
	}
	
	public static ImageIcon createBuildingDisableButtonIcon(Buildings buildingType) {
		init();
		return new ImageIcon(buttonBuildingIcons.getAbsolutePath() + "/"
				+ buildingType.getName() + "/disable.png");
	}
	
	public static ImageIcon createEOTIcon() {
		init();
		return new ImageIcon(allIcons.getAbsolutePath() + "/wait.png");
	}
	
	public static ImageIcon createSurrenderIcon() {
		init();
		return new ImageIcon(allIcons.getAbsolutePath() + "/surrender.png");
	}
	
	public static ImageIcon createAttackIcon() {
		init();
		return new ImageIcon(allIcons.getAbsolutePath() + "/attack.png");
	}
}
