package ru.amse.pomelov.starbugs.client.gui.tools;

import ru.amse.pomelov.starbugs.turns.AbstractTurn;
import ru.amse.pomelov.starbugs.turns.BirthTurn;
import ru.amse.pomelov.starbugs.units.Units;
import ru.amse.pomelov.starbugs.util.FieldPosition;

public class BirthTool extends AbstractTool {
	
	private final Units myUnitType;

	public BirthTool(Units unitType) {
		myUnitType = unitType;
	}
	
	public AbstractTurn generateTurn(FieldPosition object, FieldPosition subject) {
		return new BirthTurn(subject, myUnitType);
	}

	public boolean needsObject() {
		return false;
	}

	public int timeNeeded() {
		return myUnitType.getCost();
	}

}
