package ru.amse.pomelov.starbugs.turns;

import java.util.EnumSet;
import java.util.LinkedList;
import java.util.List;

import ru.amse.pomelov.starbugs.server.GameDispatcher;
import ru.amse.pomelov.starbugs.units.AbstractUnit;
import ru.amse.pomelov.starbugs.units.Unit;
import ru.amse.pomelov.starbugs.units.Units;
import ru.amse.pomelov.starbugs.util.FieldPosition;


public class BirthTurn extends AbstractTurn {
	
	private static final long serialVersionUID = 1L;
	
	private final Units myType;
	
	public BirthTurn(FieldPosition subject, Units type) {
		super(null, subject);
		myType = type;
	}

	@Override
	public int acceptTurn(GameDispatcher gd) {
		if (!gd.isEmptyCell(mySubject)) { 
			return -1;
		}
		if (!(gd.isActive(player, mySubject))) {
			return -1;
		}
		if (gd.isConnectedToBuildings(player, EnumSet.of(myType.getOwnBuilding()), mySubject)) {
			return myType.getCost();
		} else {
			return -1;
		}
	}

	@Override
	public void makeTurn(GameDispatcher gd) {
		List<AbstractUnit> unitList = new LinkedList<AbstractUnit>();
		unitList.add(new Unit(mySubject, player, myType));
		gd.putUnits(unitList);
	}
}
