package ru.amse.pomelov.starbugs.units;

import java.io.Serializable;
import java.util.EnumSet;

import javax.swing.ImageIcon;

import ru.amse.pomelov.starbugs.util.FieldPosition;


public abstract class AbstractUnit implements Serializable {
	
	private final FieldPosition myPosition;
	private int myPlayer;
	
	public AbstractUnit(FieldPosition position, int player) {
		myPosition = position;
		myPlayer = player;
	}

	public void setPlayer(int newOwner) {
		myPlayer = newOwner;
	}
	
	public FieldPosition getPosition() {
		return myPosition;
	}
	
	public int getPlayer() {
		return myPlayer;
	}
	
	@Override
	public boolean equals(Object obj) {
		if (obj == null) {
			return false;
		}
		if (!(obj instanceof AbstractUnit)) {
			return false;
		}
		AbstractUnit you = (AbstractUnit)obj;
		if (!myPosition.equals(you.getPosition())) {
			return false;
		}
		if (myPlayer != you.getPlayer()) {
			return false;
		}
		return true;
	}
	
	@Override
	public int hashCode() {
		return 13 + 47 * (myPlayer + 47 * myPosition.hashCode());
	}

	public abstract int getCost();
	
	public abstract int getAttackCost();
	
	public abstract int getAttackRadiuses();
	
	public abstract EnumSet<AbstractUnitTypes> getAttackTypes();
	
	public abstract boolean isAbleToBuild();
	
	public abstract AbstractUnitTypes getType();
	
	public abstract ImageIcon acceptIconFacory();
}
