package ru.amse.pomelov.starbugs.units;

import java.util.EnumSet;

import ru.amse.pomelov.starbugs.config.UnitAttributes;


public enum Units {
	WORKER(UnitAttributes.WORKER_COST,
			UnitAttributes.WORKER_ATTACK_COST,
			UnitAttributes.WORKER_ATTACK_RADIUS,			
			UnitAttributes.WORKER_ATTACK_TYPE,
			true,
			AbstractUnitTypes.HUMAN,
			Buildings.BASE,
			"Worker"),
			
	SOLDIER(UnitAttributes.SOLDIER_COST,
			UnitAttributes.SOLDIER_ATTACK_COST,
			UnitAttributes.SOLDIER_ATTACK_RADIUS,			
			UnitAttributes.SOLDIER_ATTACK_TYPE,
			false,
			AbstractUnitTypes.HUMAN,
			Buildings.BARRACKS,
			"Soldier"),
			
	ARCHER(UnitAttributes.ARCHER_COST,
			UnitAttributes.ARCHER_ATTACK_COST,
			UnitAttributes.ARCHER_ATTACK_RADIUS,			
			UnitAttributes.ARCHER_ATTACK_TYPE,
			false,
			AbstractUnitTypes.HUMAN,
			Buildings.ARCHERY,
			"Archer"),
			
	RUNNER(UnitAttributes.RUNNER_COST,
			UnitAttributes.RUNNER_ATTACK_COST,
			UnitAttributes.RUNNER_ATTACK_RADIUS,			
			UnitAttributes.RUNNER_ATTACK_TYPE,
			false,
			AbstractUnitTypes.HUMAN,
			Buildings.SMALL_WORKSHOP,
			"Runner"),
			
	BALLISTA(UnitAttributes.BALLISTA_COST,
			UnitAttributes.BALLISTA_ATTACK_COST,
			UnitAttributes.BALLISTA_ATTACK_RADIUS,			
			UnitAttributes.BALLISTA_ATTACK_TYPE,
			false,
			AbstractUnitTypes.MACHINE,
			Buildings.BIG_WORKSHOP,
			"Ballista"),
			
	CATAPULT(UnitAttributes.CATAPULT_COST,
			UnitAttributes.CATAPULT_ATTACK_COST,
			UnitAttributes.CATAPULT_ATTACK_RADIUS,			
			UnitAttributes.CATAPULT_ATTACK_TYPE,
			false,
			AbstractUnitTypes.MACHINE,
			Buildings.SMALL_FACTORY,
			"Catapult"),
			
	TANK(UnitAttributes.TANK_COST,
			UnitAttributes.TANK_ATTACK_COST,
			UnitAttributes.TANK_ATTACK_RADIUS,			
			UnitAttributes.TANK_ATTACK_TYPE,
			false,
			AbstractUnitTypes.MACHINE,
			Buildings.BIG_FACTORY,
			"Tank"),
			
	BLOCK(UnitAttributes.SOLDIER_COST,
			UnitAttributes.SOLDIER_ATTACK_COST,
			UnitAttributes.SOLDIER_ATTACK_RADIUS,			
			UnitAttributes.SOLDIER_ATTACK_TYPE,
			false,
			AbstractUnitTypes.BLOCK,
			Buildings.BASE,
			"Block");
	
	
	private Units(int cost,
					int attackCost,
					int attackRadiuses,
					EnumSet<AbstractUnitTypes> attackTypes,
					boolean buildAbility,
					AbstractUnitTypes abstractType,
					Buildings ownBuilding,
					String name) {
		myCost = cost;
		myAttackCost = attackCost;
		myAttackRadiuses = attackRadiuses;
		myAttackTypes = attackTypes;
		myBuildAbility = buildAbility;
		myAbstractType = abstractType;
		myOwnBuilding = ownBuilding;
		myName = name;
	}
	
	
	private final int myCost;
	private final int myAttackCost;
	private final int myAttackRadiuses;
	private final EnumSet<AbstractUnitTypes> myAttackTypes;
	private final boolean myBuildAbility;
	private final AbstractUnitTypes myAbstractType;
	private final Buildings myOwnBuilding;
	private final String myName;
	
	public int getCost() {
		return myCost;
	}
	public int getAttackCost() {
		return myAttackCost; 
	}
	public int getAttackRadiuses() {
		return myAttackRadiuses;
	}
	public boolean isAbleToBuild() {
		return myBuildAbility;
	}
	public AbstractUnitTypes getUnitType() {
		return myAbstractType;
	}
	public EnumSet<AbstractUnitTypes> getAttackTypes() {
		return myAttackTypes;
	}
	public Buildings getOwnBuilding() {
		return myOwnBuilding;
	}	
	public String getName() {
		return myName;
	}
}
