package ru.amse.pomelov.starbugs.util;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Map;

public class FieldPosition implements Serializable {
	

	private static final long serialVersionUID = 209198961700627344L;
	private static final Map<Long, FieldPosition> cache = new HashMap<Long, FieldPosition>();
	
	private final int myX;
	private final int myY;
	
	public static FieldPosition createPoint(int x, int y) {
		long c = x;
		c = (c << 32) | y;
		FieldPosition p = cache.get(c); 
		if (p != null) {
			return cache.get(c);
		} else {
			p = new FieldPosition(x, y);
			cache.put(c, p);
			return p;
		}
	}
	
	private FieldPosition(int x, int y) {
		myX = x;
		myY = y;
	}
	
	
	public int getX() {
		return myX;
	}

	public int getY() {
		return myY;
	}
	
	@Override
	public int hashCode() {
		return 17 + 47 * (myX + 47 * myY);
	}
	
	@Override
	public boolean equals(Object o) {
		if (!(o instanceof FieldPosition)) {
			return false;
		}
		FieldPosition p = (FieldPosition)o;
		return (myX == p.getX()) && (myY == p.getY());
	}
	
	@Override
	public String toString() {
		return "(" + myX + ", " + myY + ")";
	}
	
}