package ru.amse.pomelov.starbugs.util;

import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

public class MaskIterator implements Iterable<FieldPosition> {
	private final List<FieldPosition> result = new LinkedList<FieldPosition>(); 
	
	public MaskIterator(boolean[][] mask, FieldPosition start) {
		int sX = start.getX();
		int sY = start.getY();
		for (int i = 0; i < 4; i++) {
			for (int j = 0; j < 4; j++) {
				if (mask[j][i]) {
					result.add(FieldPosition.createPoint(sX + i, sY + j));
				}
			}
		}
	}
	
	public Iterator<FieldPosition> iterator() {
		return result.iterator();
	}

}
