package ru.amse.pomelov.starbugs.server.positioners;

import java.util.Iterator;

import ru.amse.pomelov.starbugs.util.FieldPosition;

public class PerimeterBasePositioner implements Positioner {

	private static final int MAX_NUM_OF_PLAYERS = 8;
	private final int num;
	private final FieldPosition[] result = new FieldPosition[MAX_NUM_OF_PLAYERS];
	private int cur = 0;
	
	public PerimeterBasePositioner(int num, int width, int height) throws IllegalArgumentException {
		if (num > MAX_NUM_OF_PLAYERS) {
			throw new IllegalArgumentException("Too many players");
		}
		
		this.num = num;
		
		result[0] = FieldPosition.createPoint(1, 1);
		result[1] = FieldPosition.createPoint(width - 5, height - 5);
		result[2] = FieldPosition.createPoint(width - 5, 1);
		result[3] = FieldPosition.createPoint(1, height - 5);
		result[4] = FieldPosition.createPoint(width / 2 - 2, 1);
		result[5] = FieldPosition.createPoint(width / 2 - 2, height - 5);
		result[6] = FieldPosition.createPoint(1, height / 2 - 2);
		result[7] = FieldPosition.createPoint(width - 5, height / 2 - 2);
		
	}

	public boolean hasNext() {
		return cur < num;
	}

	public FieldPosition next() {
		return result[cur++];
	}

	public void remove() {
		throw new UnsupportedOperationException();
	}

	public Iterator<FieldPosition> iterator() {
		return this;
	}

	
}
